#include <windows.h>
#pragma hdrstop

#define BUILDING_DLL
#include "MyHookDll.h"

typedef struct
{
    HHOOK ghhookKB;
    HWND hAppWnd;
} HOOKINFO, *PHOOKINFO;

HANDLE hFileMapping = NULL;
PHOOKINFO pHookInfo = NULL;
HINSTANCE ghInst = NULL;
bool gbIsWritable = false;
UINT uiKeyHookMsg = 0;

int WINAPI DllEntryPoint( HINSTANCE hinst, unsigned long reason, void *lpReserved )
{
   switch ( reason )
   {
      case DLL_PROCESS_ATTACH:
      {
         ghInst = hinst;

         TCHAR buffer[ MAX_PATH+1 ] = {0};
         ::GetModuleFileName( NULL, buffer, sizeof(buffer)/sizeof(TCHAR) );

         LPTSTR ptr = buffer;
         LPTSTR filename = buffer;

         while ( *ptr != 0 )
         {
            if ( *ptr == TEXT( '\\' ) )
            {
               filename = ::CharNext( ptr );
               ptr = filename;
            }
            else
            {
               ptr = ::CharNext( ptr );
            }
         }

         uiKeyHookMsg = ::RegisterWindowMessage( TEXT( "DiKeyHookMsg" ) );

         if ( uiKeyHookMsg )
         {
            gbIsWritable = ( lstrcmpi( filename, TEXT( "di.exe" ) ) == 0 );

            hFileMapping = ::CreateFileMapping(
               INVALID_HANDLE_VALUE,
               NULL,
               gbIsWritable ? PAGE_READWRITE : PAGE_READONLY,
               0,
               sizeof(HOOKINFO),
               TEXT("DiHook") );

            if ( hFileMapping )
            {
               pHookInfo = (PHOOKINFO) ::MapViewOfFile(
                  hFileMapping,
                  gbIsWritable ? FILE_MAP_WRITE : FILE_MAP_READ,
                  0, 0, 0 );

               if ( pHookInfo )
                  break;

               ::CloseHandle( hFileMapping );
               hFileMapping = NULL;
            }
         }
         return FALSE;
      }

      case DLL_PROCESS_DETACH:
      {
         RemoveHook();

         if ( pHookInfo )
         {
            ::UnmapViewOfFile( pHookInfo );
            pHookInfo = NULL;
         }
         if ( hFileMapping )
         {
            ::CloseHandle(hFileMapping);
            hFileMapping = NULL;
         }
         break;
      }
   }

   return TRUE;
}

BOOL __stdcall SetHook(HWND hWnd)
{
   if ( ( pHookInfo ) && ( gbIsWritable ) )
   {
      pHookInfo->hAppWnd = hWnd;

      if ( pHookInfo->ghhookKB == NULL )
         pHookInfo->ghhookKB = ::SetWindowsHookEx( WH_KEYBOARD, (HOOKPROC)&CheckKey, ghInst, 0 );

      if ( pHookInfo->ghhookKB )
         return TRUE;
   }

   return FALSE;
}

BOOL __stdcall RemoveHook(void)
{
   if ( ( pHookInfo ) && ( gbIsWritable ) )
   {
      pHookInfo->hAppWnd = NULL;

      if ( pHookInfo->ghhookKB )
      {
         ::UnhookWindowsHookEx( pHookInfo->ghhookKB );
         pHookInfo->ghhookKB = NULL;
      }
      return TRUE;
   }
   return FALSE;
}

LRESULT CALLBACK CheckKey(int nCode, WPARAM wParam, LPARAM lParam)
{

   LRESULT res = 0;

   if ( pHookInfo )
   {
      try
      {
         if ( (nCode >= 0)
              && (nCode != HC_NOREMOVE)
              && ((lParam & 0x40000000) == 0) // Skip if it's a repeat
              && (lParam & 0x20000000) ) // Check if Alt is pressed
         {
            if ( pHookInfo->hAppWnd ) // Skip if no App window
            {
               // Send key information to the App window
               ::PostMessage( pHookInfo->hAppWnd, uiKeyHookMsg, 0, lParam );
            }
         }
         res = ::CallNextHookEx( pHookInfo->ghhookKB, nCode, wParam, lParam );
      }
      catch ( ... )
      {
         // ...
      }
   }
   return ( res );
}

UINT __stdcall GetHookMsg( void )
{
   return ( uiKeyHookMsg );
}

